<script setup lang="ts">
import AuthApi from '@/api/authApi'
import UserAvatar from '@/layouts/components/UserAvatar.vue'
import { computed } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'

const store = useStore()
const router = useRouter()

const authApi = new AuthApi()

interface User {
  username: string
  role: string
  email?: string // Propiedades opcionales pueden ser marcadas con ?
  active: boolean
  git_lab_user?: object
  id: string
  internal: boolean
  name: string
  rol: string
  surname_1: string
  surname_2: string
}

// TODO: Get type from backend
const userData = computed<User>(() => store.state.user)

console.log('[userProfile.vue] Stored user is ', store.state.user)
console.log('[userProfile.vue] global store is ', store)

const logout = async () => {
  // Remove userToken from Storage
  // Remove userData from Storage
  await authApi.logout()

  // ℹ️ We had to remove abilities in then block because if we don't nav menu items mutation is visible while redirecting user to login page
  // Redirecting to Login page
  await router.push({ name: 'login' })
  // Clear sessionStorage in order to avoid conflicts
  sessionStorage.removeItem('user');
  window.location.reload();
}

/*******
 * 
 */
const initials = ref('')
const variant = ref('')

// Funciones para calcular iniciales y variantes basadas en el usuario y rol
const updateInitials = (username: string) => {
  initials.value = username.slice(0, 2).toUpperCase()
  console.log('UserAvatar: this.initials', initials.value)
}

const updateVariant = (role: string) => {
  const roleNormalized = role.trim().toLowerCase()

  const roleVariantMap: Record<string, string> = {
    root: 'error',
    admin: 'primary',
    developer: 'warning',
    user: 'success',
  }

  variant.value = roleVariantMap[roleNormalized] || 'secondary'
  console.log('UserAvatar: this.variant', variant.value)
}

// Llamadas iniciales a las funciones para establecer los valores iniciales
if (userData.value) {
  updateInitials(userData.value.username)
  updateVariant(userData.value.role)
}
</script>

<template>
  <VBadge
    v-if="userData"
    dot
    bordered
    location="bottom right"
    offset-x="3"
    offset-y="3"
    color="success"
  >
    <VAvatar
      class="cursor-pointer"
      size="40"
      :color="variant"
      variant="tonal"
    >
      {{ initials }}
      <!-- SECTION Menu -->
      <VMenu
        activator="parent"
        width="230"
        location="bottom end"
        offset="14px"
      >
        <VList>
          <!-- 👉 User Avatar & Name -->
          <VListItem>
            <template #prepend>
              <VListItemAction start>
                <VBadge
                  dot
                  location="bottom right"
                  offset-x="3"
                  offset-y="3"
                  color="success"
                >
                  <!-- La clase UserAvatar se encarga de mostrar las iniciales y el color del avatar -->
                  <!-- Las funciones que estan aqui adentro se repiten en esta mismA CLASE para el User Profile -->
                  <UserAvatar
                    :username="userData.username"
                    :role="userData.role"
                  />
                </VBadge>
              </VListItemAction>
            </template>

            <VListItemTitle class="font-weight-semibold">
              {{ userData.username }}
            </VListItemTitle>
            <VListItemSubtitle>{{ (userData && userData.role) ? userData.role : undefined }}</VListItemSubtitle>
          </VListItem>

          <VDivider class="my-2" />

          <!-- 👉 Profile
          <VListItem link>
            <template #prepend>
              <VIcon
                class="me-2"
                icon="tabler-user"
                size="22"
              />
            </template>

            <VListItemTitle>Profile</VListItemTitle>
          </VListItem>
          -->

          <!-- 👉 Settings -->
          <VListItem :to="{ name: 'user-setting' }" link>
            <template #prepend>
              <VIcon
                class="me-2"
                icon="tabler-settings"
                size="22"
              />
            </template>

            <VListItemTitle>Settings</VListItemTitle>
          </VListItem>

          <!-- 👉 Pricing
          <VListItem link>
            <template #prepend>
              <VIcon
                class="me-2"
                icon="tabler-currency-dollar"
                size="22"
              />
            </template>

            <VListItemTitle>Pricing</VListItemTitle>
          </VListItem>
          -->

          <!-- 👉 FAQ 
          <VListItem link>
            <template #prepend>
              <VIcon
                class="me-2"
                icon="tabler-help"
                size="22"
              />
            </template>

            <VListItemTitle>FAQ</VListItemTitle>
          </VListItem>
          -->

          <!-- Divider -->
          <VDivider class="my-2" />

          <!-- 👉 Logout -->
          <VListItem @click="logout">
            <template #prepend>
              <VIcon
                class="me-2"
                icon="tabler-logout"
                size="22"
              />
            </template>

            <VListItemTitle>Logout</VListItemTitle>
          </VListItem>
        </VList>
      </VMenu>
      <!-- !SECTION -->
    </VAvatar>
  </VBadge>
</template>
